#property copyright "EXOLON" 
/////////////////////////////////////////////////////////////////////////
//     ,  .//
//     ,   .   //
//   .  -        //
//   4 ,     (   )//                                 
//                         //
//                                                              EXOLON  //
/////////////////////////////////////////////////////////////////////////


#define MAGIC 12      //   ,    
extern double MaximumRisk        = 0.1;//   
extern double Lots               = 0.1; // 
extern int    DecreaseFactor     = 0;   //  (      )
extern double StopLoss=100;   // stoploss
extern double TakeProfit=50;  //  
extern double lTrailingStop  = 40;
extern double sTrailingStop  = 40; 
extern bool UseSound = True;
extern bool UseDayCorrections = false;
extern string NameFileSound = "alert.wav";


//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC)
              {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
          if(OrderType()==OP_BUYSTOP)  buys++;
         if(OrderType()==OP_SELLSTOP) sells++;
        }
     }
//----
   if(buys>0) return(buys);
   else       return(-sells);
  
//if(AccountNumber()!=12345) return(-1);  //   
//if(IsDemo()==FALSE)           return(-1);  //   !
// if(IsTesting()==TRUE)          return(-1);  //    
//if(ServerAddress( )!="MetaQuotes Demo") return(-1);  //    MetaQuotes
  
  string SYM = Symbol( );
  int digits = MarketInfo(SYM, MODE_DIGITS); //    
  
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     
   int    losses=0;                  
//---- 
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- 
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- 
   if(lot<0.1) lot=0.1;
   return(lot);
  }
  
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
  
//---- 
  
   int    ticket;
   double fatlLAST,rtflLAST,fatlPREV,rtflPREV,rbciLAST,rbciPREV,satlPREV,satlLAST,stlmLAST,stlmPREV,
   ftlmLAST,ftlmPREV,Heiken2,Heiken3,satlLASTd,satlPREVd,distart,distop,t1,t2,t3,t4,fatlLASTd,fatlPREVd,Heiken2d,Heiken3d;
  
  
//----   SELL1 & BUY1 -     atcf ()   
   bool   Sell1=0, Buy1=0;
     
//----   SELLd1 & BUYd1 -     dinapoli (1  -     >    1
   bool   Selld1=0, Buyd1 =0;
  
 //----  SELLd2 & BUYd2 -     dinapoli (2  -      >   ,  2) 

  bool   Selld2=0, Buyd2=0;
 
 //----  SELLd3 & BUYd3 -     dinapoli (3  -      1    2 >   ,  2) 
 
  bool   Selld3=0, Buyd3=0;
 
  //----  SELLd4 & BUYd4 -     dinapoli (4  -      2    3  50 . >   , 
  //----   3,     ) 
  
  bool   Selld4=0, Buyd4=0;
  
  bool   Selld5=0, Buyd5=0;
  
  bool   Sell0=0, Buy0=0;  //   
 
 if(Volume[0]>3) return;
fatlLAST=iCustom(NULL,PERIOD_H4,"fatl",0,0,0);
fatlPREV=iCustom(NULL,PERIOD_H4,"fatl",0,0,1);
rtflLAST=iCustom(NULL,PERIOD_H4,"rftl",0,0,0);
rtflPREV=iCustom(NULL,PERIOD_H4,"rftl",0,0,1);
rbciLAST=iCustom(NULL,PERIOD_H4,"rbci",0,0,0);
rbciPREV=iCustom(NULL,PERIOD_H4,"rbci",0,0,1);
satlPREV=iCustom(NULL,PERIOD_H4,"SATL",0,0,1);
satlLAST=iCustom(NULL,PERIOD_H4,"SATL",0,0,0);
stlmLAST=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,0,0);
stlmPREV=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,0,1);
ftlmLAST=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,1,0);
ftlmPREV=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,1,1);
Heiken2=iCustom(NULL,PERIOD_H4,"#HeikenAshi",2,0);
Heiken3=iCustom(NULL,PERIOD_H4,"#HeikenAshi",3,0);
distart= NormalizeDouble( ObjectGet("Start line",OBJPROP_PRICE1),MarketInfo( Symbol(), MODE_DIGITS ) );
distop= NormalizeDouble( ObjectGet("Stop line",OBJPROP_PRICE1),MarketInfo( Symbol(), MODE_DIGITS ) );
t1=NormalizeDouble(ObjectGet("Target1 line",OBJPROP_PRICE1),MarketInfo( Symbol(), MODE_DIGITS) ) ;
t2=NormalizeDouble(ObjectGet("Target2 line",OBJPROP_PRICE1),MarketInfo( Symbol(), MODE_DIGITS )) ;
t3=NormalizeDouble(ObjectGet("Target3 line",OBJPROP_PRICE1),MarketInfo( Symbol(), MODE_DIGITS )) ;
t4=NormalizeDouble(ObjectGet("Fantasy line",OBJPROP_PRICE1),MarketInfo( Symbol(), MODE_DIGITS )) ;
satlLASTd=iCustom(NULL,PERIOD_D1,"SATL",0,0,0);
satlPREVd=iCustom(NULL,PERIOD_D1,"SATL",0,0,1);
fatlLASTd=iCustom(NULL,PERIOD_D1,"fatl",0,0,0);
fatlPREVd=iCustom(NULL,PERIOD_D1,"fatl",0,0,1);
Heiken2d=iCustom(NULL,PERIOD_D1,"#HeikenAshi",2,0);
Heiken3d=iCustom(NULL,PERIOD_D1,"#HeikenAshi",3,0);


//--------  

   Sell1=   fatlLAST < fatlPREV  && satlLAST < satlPREV && fatlLAST < rtflLAST  && rbciLAST < rbciPREV && Heiken2 > Heiken3 && stlmLAST < stlmPREV && distart < distop && satlLASTd <= satlPREVd;
   Buy1=    fatlLAST > fatlPREV && fatlLAST > rtflLAST && satlLAST > satlPREV && rbciLAST > rbciPREV && Heiken2 < Heiken3 && stlmLAST > stlmPREV &&  distart > distop && satlLASTd >= satlPREVd;
   
//-------------
   Selld1 = PRICE_OPEN > distart;
   Buyd1 = PRICE_OPEN < distart;
   
//------------- 
    Selld2 = PRICE_OPEN <= distart > t1;  
    Buyd2 = PRICE_OPEN >= distart < t1;
    
 //------------- 
    Selld3 = PRICE_OPEN <= t1 >= t2;  
    Buyd3 = PRICE_OPEN >= t1 <= t2;
       
 //------------- 
    Selld4 = PRICE_OPEN < t2 >= t3;  
    Buyd4 = PRICE_OPEN > t2 <= t3;
       
//------------- 
    Selld5 = PRICE_OPEN < t3 >= t4;  
    Buyd5 = PRICE_OPEN > t3 <= t4;
    
 //-------------  
 
    Sell0 = fatlLASTd < fatlPREVd && Heiken2d > Heiken3d && satlLASTd > satlPREVd; 
    Buy0 = fatlLASTd > fatlPREVd && Heiken2d < Heiken3d && satlLASTd < satlPREVd;

//------------- 1 

   if  (Sell1 == 1 && Selld1 == 1)
 
     {
      ticket=OrderSend(Symbol(),OP_SELLSTOP,LotsOptimized(),distart,5,distop,t1,"ATCF_pip din1",MAGIC,0,Red);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) { Print("SELL order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening SELL order : ",GetLastError()); 
      return(0); 
     }
 //----------------
 
   if (Buy1 == 1 && Buyd1 == 1) 
  
     {
      ticket=OrderSend(Symbol(),OP_BUYSTOP,LotsOptimized(),distart,5,distop,t1,"ATCF_pip din1",MAGIC,0,Green);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))  { Print("BUY order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening BUY order : ",GetLastError()); 
      
      return(0); 
     }

   
//---- 2  

 if  (Sell1 == 1 && Selld2 == 1)
 
     {
      ticket=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,5,distop,t1,"ATCF_pip din2",MAGIC,0,Red);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) { Print("SELL order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening SELL order : ",GetLastError()); 
      return(0); 
     }
 //----------------
 
   if (Buy1 == 1 && Buyd2 == 1) 
  
     {
      ticket=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,5,distop,t1,"ATCF_pip din2",MAGIC,0,Green);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))  { Print("BUY order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening BUY order : ",GetLastError()); 
      
      return(0); 
     }
      
      
 //---- 3  

 if  (Sell1 == 1 && Selld3 == 1)
 
     {
      ticket=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,5,Bid+StopLoss*Point,t2,"ATCF_pip din3",MAGIC,0,Red);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) { Print("SELL order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening SELL order : ",GetLastError()); 
      return(0); 
     }
 //----------------
 
   if (Buy1 == 1 && Buyd3 == 1) 
  
     {
      ticket=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,5,Ask-StopLoss*Point,t2,"ATCF_pip din3",MAGIC,0,Green);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))  { Print("BUY order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening BUY order : ",GetLastError()); 
      
      return(0); 
     }     
    
      
    //---- 4  

 if  (Sell1 == 1 && Selld4 == 1)
 
     {
      ticket=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,5,Bid+StopLoss*Point,t3,"ATCF_pip din4",MAGIC,0,Red);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) { Print("SELL order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening SELL order : ",GetLastError()); 
      return(0); 
     }
 //----------------
 
   if (Buy1 == 1 && Buyd4 == 1) 
  
     {
      ticket=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,5,Ask-StopLoss*Point,t3,"ATCF_pip din4",MAGIC,0,Green);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))  { Print("BUY order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening BUY order : ",GetLastError()); 
      
      return(0); 
     }       
     
      //---- 5  

 if  (Sell1 == 1 && Selld5 == 1)
 
     {
      ticket=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,5,Bid+StopLoss*Point,t3,"ATCF_pip din5",MAGIC,0,Red);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) { Print("SELL order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening SELL order : ",GetLastError()); 
      return(0); 
     }
 //----------------
 
   if (Buy1 == 1 && Buyd5 == 1) 
  
     {
      ticket=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,5,Ask-StopLoss*Point,t3,"ATCF_pip din5",MAGIC,0,Green);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))  { Print("BUY order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening BUY order : ",GetLastError()); 
      
      return(0); 
     }     
     
       
    //----   

 if   (Sell0 == 1 && Selld2 == 1 && Sell1 == 1)
 
     {
     if  (UseDayCorrections)
      ticket=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,5,distop,t2,"ATCF_daykor",MAGIC,0,Red);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) { Print("SELL order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening SELL order : ",GetLastError()); 
      return(0); 
     }
 //----------------
 
   if (Buy0 == 1 && Buyd2 == 1 && Buy1 == 1)
  if (UseDayCorrections)
     {
      ticket=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,5,distop,t2,"ATCF_daykorr",MAGIC,0,Green);
      if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))  { Print("BUY order opened : ",OrderOpenPrice());}
        if (UseSound) PlaySound(NameFileSound); 
        }
      else Print("Error opening BUY order : ",GetLastError()); 
      
      return(0); 
     }  
      
  }
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
  
//----
  
   double fatlLAST,rtflLAST,fatlPREV,rtflPREV,rbciLAST,rbciPREV,
satlPREV,satlLAST,stlmLAST,stlmPREV,ftlmLAST,ftlmPREV,Heiken2,Heiken3;

   bool   Sell1=0, Buy1=0;

//----   
// if(Volume[0]>1) return;
fatlLAST=iCustom(NULL,PERIOD_H4,"fatl",0,0,0);
rtflLAST=iCustom(NULL,PERIOD_H4,"rftl",0,0,0);
fatlPREV=iCustom(NULL,PERIOD_H4,"fatl",0,0,1);
rtflPREV=iCustom(NULL,PERIOD_H4,"rftl",0,0,1);
rbciLAST=iCustom(NULL,PERIOD_H4,"rbci",0,0,0);
rbciPREV=iCustom(NULL,PERIOD_H4,"rbci",0,0,1);
satlPREV=iCustom(NULL,PERIOD_H4,"SATL",0,0,1);
satlLAST=iCustom(NULL,PERIOD_H4,"SATL",0,0,0);
stlmLAST=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,0,0);
stlmPREV=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,0,1);
ftlmLAST=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,1,0);
ftlmPREV=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,1,1);
Heiken2=iCustom(NULL,PERIOD_H4,"#HeikenAshi",2,0);
Heiken3=iCustom(NULL,PERIOD_H4,"#HeikenAshi",3,0);



    
   Sell1 =  fatlLAST<fatlPREV  && rbciPREV>rbciLAST  && Heiken2>Heiken3 && stlmLAST<=stlmPREV && satlLAST<=satlPREV; 
   Buy1 =  fatlLAST>fatlPREV  && rbciPREV<rbciLAST && Heiken2<Heiken3 && stlmLAST>=stlmPREV && satlLAST>=satlPREV;
 
//---- SELL1 & BUY1 -     4h ()

  for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=MAGIC) continue;
      if(OrderType()==OP_BUY)
        {
          if (Sell1==1)
             {
              OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
              return(0);
             }
        }    
              
      if(OrderType()==OP_SELL)
        {
           if (Buy1==1)
             {
              OrderClose(OrderTicket(),OrderLots(),Ask,3,Green);
              return(0);
             }
        }      
         
            
     }
     
     TrailingPositionsBuy(lTrailingStop);
    TrailingPositionsSell(sTrailingStop);
    return (0);
   }
bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}
     
void TrailingPositionsBuy(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) { 
            if (OrderType()==OP_BUY) { 
               if (Bid-OrderOpenPrice()>trailingStop*Point) { 
                  if (OrderStopLoss()<Bid-trailingStop*Point) 
                     ModifyStopLoss(Bid-trailingStop*Point); 
               } 
            } 
         } 
      } 
   } 
} 
void TrailingPositionsSell(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) { 
            if (OrderType()==OP_SELL) { 
               if (OrderOpenPrice()-Ask>trailingStop*Point) { 
                  if (OrderStopLoss()>Ask+trailingStop*Point || OrderStopLoss()==0)  
                     ModifyStopLoss(Ask+trailingStop*Point); 
               } 
            } 
         } 
      } 
   } 
} 
void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   if (fm && UseSound) PlaySound(NameFileSound); 
//----
    }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
//----
  }
//+------------------------------------------------------------------+